function showMaterialType(action, data) {


    var id = "";
    var code = "";
    var name = "";
    var address = "";
    var contact_person = "";
    var fixed_no = "";
    var mobile_no = "";
    var button = "Save";

    if (action == 'edit') {
        id = data.shipping_agent_id;
        code = data.code;
        name = data.name;
        address = data.address;
        contact_person = data.contact_person;
        fixed_no = data.fixed_no;
        mobile_no = data.mobile_no;
        button = "Update";
    }
    $('#settingsAddModalBody').empty();
    var content = '<div class="form-row">';
    content += '<div class="col-md-12 mb-3" id="divCode">';
    content += '<label for="txtCode">Code</label>';
    content += '<input type="text" class="form-control" id="txtShippingCode" name="code" placeholder="Shipping Code" value="' + code + '" data-id="' + id + '">';
    content += '</div>';
    content += '<div class="col-md-12 mb-3" id="divName">';
    content += '<label for="txtName">Name</label>';
    content += '<input type="text" class="form-control" id="txtShippingName" name="name" placeholder="Name" value="' + name + '" data-id="' + id + '">';
    content += '</div>';
    content += '<div class="col-md-12 mb-3" id="divAddress">';
    content += '<label for="txtAddress">Address</label>';
    content += '<input type="text" class="form-control" id="txtShippingAddress" name="name" placeholder="Address" value="' + address + '" data-id="' + id + '">';
    content += '</div>';
    content += '<div class="col-md-12 mb-3" id="divContactperson">';
    content += '<label for="txtContactPerson">Contact Person</label>';
    content += '<input type="text" class="form-control" id="txtContactPerson" name="contact_person" placeholder="Contact Person" value="' + contact_person + '" data-id="' + id + '">';
    content += '</div>';
    content += '<div class="col-md-12 mb-3" id="divFixedNo">';
    content += '<label for="txtFixdNo">Fixed No</label>';
    content += '<input type="tel" class="form-control" id="textFixedNo" name="fixed_no" placeholder="Fixed No" value="' + fixed_no + '" data-id="' + id + '">';
    content += '</div>';
    content += '<div class="col-md-12 mb-3" id="divMobileNo">';
    content += '<label for="txtMobileNo">Mobile No</label>';
    content += '<input type="tel" class="form-control" id="txtMobileNo" name="mobile_no" placeholder="Mobile No" value="' + mobile_no + '" data-id="' + id + '">';
    content += '</div>';
    content += '</div>';
    $('#settingsAddModalBody').append(content);
    $('#settingsAddModalTitle').text('Shipping Agent');
    $('#btnDiv').empty();
    $('#btnDiv').append('<button type="button" class="btn btn-primary" id="btnName">' + button + '</button');
    $("#settingsAddModal").modal('toggle');


    $('#btnName').on('click', function () {
        var action = $(this).text();

        if (action == 'Save') {
            saveMaterialType();
        } else if (action == 'Update') {
            updateShippingAegntData();
        }
    });

}


function getAllMaterialType() {

    $.ajax({
        type: "GET",
        url: '/sd/SettingsController/getAllShippingData',
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                var result = response.data.result;
                appendMaterialType(result);

            } else {
                showErrorMessage();
            }

        },
        error: function (error) {
            console.log(error);
            showErrorMessage();
        },
        complete: function () {
            $('.ti-settings').show();
            $('.spinner-border').hide();
        }

    });
}


function saveMaterialType() {
    $.ajax({
        type: "POST",
        url: '/sd/SettingsController/saveShippingAgent',
        data: {
            shipping_code: $('#txtShippingCode').val(),
            Shipping_name: $('#txtShippingName').val(),
            shipping_address: $('#txtShippingAddress').val(),
            contact_person: $('#txtContactPerson').val(),
            fixed_no: $('#textFixedNo').val(),
            mobile_no: $('#txtMobileNo').val(),
        },
        headers: {
            'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
        },
        timeout: 800000,
        beforeSend: function () {
            $("#settingsAddModal").modal('hide');
        },
        success: function (response) {

            if (response.data.success) {

                showSuccessMessage("Material Type has been saved successfully...");
                getAllMaterialType();

            } else {
                showErrorMessage();
            }

        },
        error: function (error) {
            console.error(error);
            showErrorMessage();
        },
        complete: function () {

        }

    });
}

function updateShippingAegntData() {

    $.ajax({
        type: "PO",
        url: '/sd/SettingsController/updateShippingAgentData/' + $('#txtShippingCode').attr('data-id'),
        data: {
            shipping_code: $('#txtShippingCode').val(),
            Shipping_name: $('#txtShippingName').val(),
            shipping_address: $('#txtShippingAddress').val(),
            contact_person: $('#txtContactPerson').val(),
            fixed_no: $('#textFixedNo').val(),
            mobile_no: $('#txtMobileNo').val(),
        },
        headers: {
            'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
        },
        timeout: 800000,
        beforeSend: function () {
            $("#settingsAddModal").modal('hide');
        },
        success: function (response) {
            console.log(response);

            if (response.data.success) {

                showSuccessMessage("Material Type has been updated successfully...");
                getAllMaterialType();


            } else {
                showErrorMessage();
            }

        },
        error: function (error) {
            console.log(error);
            showErrorMessage();
        },
        complete: function () {

        }

    });
}


function editMaterialType(id) {
    $.ajax({
        type: "GET",
        url: '/sd/SettingsController/getShippingData/' + id,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                var result = response.data.result;
                showMaterialType('edit', result);


            } else {
                showErrorMessage();
            }

        },
        error: function (error) {
            console.log(error);
            showErrorMessage();
        },
        complete: function () {
            $('.ti-settings').show();
            $('.spinner-border').hide();
        }

    });
}

function appendMaterialType(result) {

    var disable = { 0: "", 1: "checked" }
    var tbody = "";


    for (i = 0; i < result.length; i++) {
        var row = "<tr>";
        var str_id = "'" + result[i].shipping_agent_id + "'";
        row += '<td class="id" id="' + result[i].shipping_agent_id + '">' + generateID(result[i].shipping_agent_id) + '</td>';
        row += '<td>' + result[i].code + '</td>';
        row += '<td>' + result[i].name + '</td>';
        row += '<td>' + result[i].address + '</td>';
        row += '<td>' + result[i].contact_person + '</td>';
        row += '<td>' + result[i].fixed_no + '</td>';
        row += '<td>' + result[i].mobile_no + '</td>';
        row += '<td class="edit edit_name">';
        row += '<button type="button" class="btn btn-primary setting-edit-btn" id="' + result[i].shipping_agent_id + '" onclick="editMaterialType(' + str_id + ')">';
        row += '<i class="fa fa-pencil-square-o" aria-hidden="true"></button>';

        row += '</td>';
        row += '<td class="disable disable_town">';
        row += '<label class="switch">';
        row += '<input type="checkbox"  id="' + result[i].shipping_agent_id + '" onchange="disableMaterialType(event,' + str_id + ')" ' + disable[result[i].status] + '>';



        row += '<span class="slider round"></span>';
        row += '</label>';
        row += '</td>';
        row += '</tr>';
        tbody += row;
    }
    $('#tblMaterialType').empty();
    $('#tblMaterialType').append(tbody);
}








/**
* generateID
* This function is used to generate id
* @param id This is the paramter to require id
*/
function generateID(id) {

    let pattern = {
        1: "0000",
        2: "000",
        3: "00",
        4: "0",
    };
    var length = Math.ceil(Math.log(id + 1) / Math.LN10);
    return pattern[length] + id;
}


/**
* showSuccessMessage
* This function is used to show success message.
* @param message This is the paramter to require message content
*/
function showSuccessMessage(message) {

    toastr.success(message);
}



/**
* showErrorMessage
* This function is used to show error message.
* @param message This is the paramter to require message content
*/
function showErrorMessage() {
    toastr.error('Something went wrong');
}


/**
* showWarrningMessage
* This function is used to show warning message.
* @param message This is the paramter to require message content
*/
function showWarningMessage(message) {

    toastr.warning(message);
}
